博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
CodeForces Round 200 Div2
阅读量:4674 次
发布时间:2019-06-09

本文共 14106 字,大约阅读时间需要 47 分钟。

  这次比赛出的题真是前所未有的水!只用了一小时零十分钟就过了前4道题,不过E题还是没有在比赛时做出来,今天上午我又把E题做了一遍,发现其实也很水.昨天晚上人品爆发,居然排到Rank 55,运气好的话没准能领到T-shirt.除此之外,锁上程序之后,看到一个人数组开小了,我还提交了一个大数据,成功Hack了一次,然后Room排名顿时升到第1. 

My submissions
 
 
# When Who Problem Lang Verdict Time Memory
Sep 15, 2013 8:05:15 AM GNU C++ Accepted 186 ms 1536 KB
Sep 15, 2013 8:00:16 AM GNU C++ Wrong answer on test 4 30 ms 800 K
 
My contest submissions
 
 
# When Who Problem Lang Verdict Time Memory
Sep 14, 2013 8:42:37 PM GNU C++ Accepted 30 ms 200 KB
Sep 14, 2013 8:39:38 PM GNU C++ Runtime error on pretest 7 30 ms 100 KB
Sep 14, 2013 8:18:06 PM GNU C++ Accepted 30 ms 0 KB
Sep 14, 2013 7:48:16 PM GNU C++ Accepted 30 ms 0 KB
Sep 14, 2013 7:36:06 PM GNU C++ Accepted 62 ms 0 KB

A. Magnets

time limit per test 1 second

memory limit per test 256 megabytes

input standard input

output standard output

Mad scientist Mike entertains himself by arranging rows of dominoes. He doesn't need dominoes, though: he uses rectangular magnets instead. Each magnet has two poles, positive (a "plus") and negative (a "minus"). If two magnets are put together at a close distance, then the like poles will repel each other and the opposite poles will attract each other. Mike starts by laying one magnet horizontally on the table. During each following step Mike adds one more magnet horizontally to the right end of the row. Depending on how Mike puts the magnet on the table, it is either attracted to the previous one (forming a group of multiple magnets linked together) or repelled by it (then Mike lays this magnet at some distance to the right from the previous one). We assume that a sole magnet not linked to others forms a group of its own.

 

Mike arranged multiple magnets in a row. Determine the number of groups that the magnets formed.

Input

The first line of the input contains an integer n (1 ≤ n ≤ 100000) — the number of magnets. Then n lines follow. The i-th line (1 ≤ i ≤ n) contains either characters "01", if Mike put the i-th magnet in the "plus-minus" position, or characters "10", if Mike put the magnet in the "minus-plus" position.

Output

On the single line of the output print the number of groups of magnets.

Sample test(s)

Input

6 10 10 10 01 10 10

Output

3

Input

4 01 01 10 10

Output

2

Note

The first testcase corresponds to the figure. The testcase has three groups consisting of three, one and two magnets. The second testcase has two groups, each consisting of two magnets.

题意:N块磁铁,0表示N极,1表示S极,同性相斥,异性相吸.把块磁铁排成一行,判断形成了几个大块.

思路:纯模拟.

#include
int main(){ int N; char str[5],cur[5]; scanf("%d",&N); scanf("%s",str); int T=1; for (int i=1;i
View Code
B. Simple Molecules
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mad scientist Mike is busy carrying out experiments in chemistry. Today he will attempt to join three atoms into one molecule.

A molecule consists of atoms, with some pairs of atoms connected by atomic bonds. Each atom has a valence number — the number of bonds the atom must form with other atoms. An atom can form one or multiple bonds with any other atom, but it cannot form a bond with itself. The number of bonds of an atom in the molecule must be equal to its valence number.

 

Mike knows valence numbers of the three atoms. Find a molecule that can be built from these atoms according to the stated rules, or determine that it is impossible.

Input

The single line of the input contains three space-separated integers a, b and c (1 ≤ a, b, c ≤ 106) — the valence numbers of the given atoms.

Output

If such a molecule can be built, print three space-separated integers — the number of bonds between the 1-st and the 2-nd, the 2-nd and the 3-rd, the 3-rd and the 1-st atoms, correspondingly. If there are multiple solutions, output any of them. If there is no solution, print "Impossible" (without the quotes).

Sample test(s)
Input
1 1 2
Output
0 1 1
Input
3 4 5
Output
1 3 2
Input
4 1 1
Output
Impossible

Note

The first sample corresponds to the first figure. There are no bonds between atoms 1 and 2 in this case. The second sample corresponds to the second figure. There is one or more bonds between each pair of atoms. The third sample corresponds to the third figure. There is no solution, because an atom cannot form bonds with itself. The configuration in the fourth figure is impossible as each atom must have at least one atomic bond.

题意:有3个原子,它们的化合价分别为a,b,c,假设不能和自身形成共价键,问能否由这3个原子构成1个分子,如果能,输出一种可行解,否则输出"Impossible".

思路:枚举第一个原子和第二个原子见得共价键数目,其余两对原子间的共价键数可以O(1)确定,关键是判定条件

1.两两间形成的共价键数非负.

2.两两间形成的共价键数中最多有两个0(排除图4中的情况)

3.p[1]+p[3]==v[1],保证解得正确性

#include
int main(){ int v[5],p[5]; for (int i=1;i<=3;i++) scanf("%d",&v[i]); bool flag=false; for (int i=0;i<=v[1];i++) { p[1]=i; p[2]=v[2]-i; p[3]=v[3]-p[2]; if (p[3]+p[1]!=v[1]) continue; int T=0; for (int i=1;i<=3;i++) if (p[i]==0) T++; if (T>=2) continue; if (p[1]>=0 && p[2]>=0 && p[3]>=0) { flag=true; break; } } if (flag) printf("%d %d %d\n",p[1],p[2],p[3]); else printf("Impossible\n"); return 0;}
View Code
C. Rational Resistance
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mad scientist Mike is building a time machine in his spare time. To finish the work, he needs a resistor with a certain resistance value.

However, all Mike has is lots of identical resistors with unit resistance R0 = 1. Elements with other resistance can be constructed from these resistors. In this problem, we will consider the following as elements:

  1. one resistor;
  2. an element and one resistor plugged in sequence;
  3. an element and one resistor plugged in parallel.

 

 

With the consecutive connection the resistance of the new element equals R = Re + R0. With the parallel connection the resistance of the new element equals . In this case Re equals the resistance of the element being connected.

Mike needs to assemble an element with a resistance equal to the fraction . Determine the smallest possible number of resistors he needs to make such an element.

Input

The single input line contains two space-separated integers a and b (1 ≤ a, b ≤ 1018). It is guaranteed that the fraction is irreducible. It is guaranteed that a solution always exists.

Output

Print a single number — the answer to the problem.

Please do not use the %lld specifier to read or write 64-bit integers in С++. It is recommended to use the cin, cout streams or the %I64d specifier.

Sample test(s)
Input
1 1
Output
1
Input
3 2
Output
3
Input
199 200
Output
200
Note

In the first sample, one resistor is enough.

In the second sample one can connect the resistors in parallel, take the resulting element and connect it to a third resistor consecutively. Then, we get an element with resistance . We cannot make this element using two resistors.

题意:用最少的1Ω电阻拼出指定阻值(a/b)电阻.元件之间可以以串联或并联的方式连接. 

思路: 显然电阻越并越小,a/b的整数部分可以串联若干1Ω电阻解决.此时,有这样一条重要结论:如果最少用K个电阻构成a/bΩ电阻,那么b/a也需K个(只需改变所有的串并联关系即可).所以此时若b>a,只需交换a,b的值,重复上一步骤.

#include
int main(){ __int64 a,b,T=0; scanf("%I64d%I64d",&a,&b); while (a!=b) { if (a==0) break; if (a
0) T++; printf("%I64d\n",T); return 0;}
View Code
D. Alternating Current
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mad scientist Mike has just finished constructing a new device to search for extraterrestrial intelligence! He was in such a hurry to launch it for the first time that he plugged in the power wires without giving it a proper glance and started experimenting right away. After a while Mike observed that the wires ended up entangled and now have to be untangled again.

The device is powered by two wires "plus" and "minus". The wires run along the floor from the wall (on the left) to the device (on the right). Both the wall and the device have two contacts in them on the same level, into which the wires are plugged in some order. The wires are considered entangled if there are one or more places where one wire runs above the other one. For example, the picture below has four such places (top view):

 

Mike knows the sequence in which the wires run above each other. Mike also noticed that on the left side, the "plus" wire is always plugged into the top contact (as seen on the picture). He would like to untangle the wires without unplugging them and without moving the device. Determine if it is possible to do that. A wire can be freely moved and stretched on the floor, but cannot be cut.

To understand the problem better please read the notes to the test samples.

Input

The single line of the input contains a sequence of characters "+" and "-" of length n (1 ≤ n ≤ 100000). The i-th (1 ≤ i ≤ n) position of the sequence contains the character "+", if on the i-th step from the wall the "plus" wire runs above the "minus" wire, and the character "-" otherwise.

Output

Print either "Yes" (without the quotes) if the wires can be untangled or "No" (without the quotes) if the wires cannot be untangled.

Sample test(s)
Input
-++-
Output
Yes
Input
+-
Output
No
Input
++
Output
Yes
Input
-
Output
No
Note

The first testcase corresponds to the picture in the statement. To untangle the wires, one can first move the "plus" wire lower, thus eliminating the two crosses in the middle, and then draw it under the "minus" wire, eliminating also the remaining two crosses.

In the second testcase the "plus" wire makes one full revolution around the "minus" wire. Thus the wires cannot be untangled:

 

In the third testcase the "plus" wire simply runs above the "minus" wire twice in sequence. The wires can be untangled by lifting "plus" and moving it higher:

 

In the fourth testcase the "minus" wire runs above the "plus" wire once. The wires cannot be untangled without moving the device itself:

 题意:两根两端固定的电线经过N个节点的交叉,问是否能将电线分成完全不相交的状态.'+'表示交叉点处火线在上边,'-'表示交叉点处零线在上边.

 思路:显然,当连续出现两个'+'或两个'-'时,将这一部分去掉对最终结果没有影响.所以可以用栈来解决这个问题.从左往右扫描序列当栈为空或栈顶元素与当前元素不同时将当前元素入栈.否则将栈顶元素弹出.若最终得到空栈,则可以分开.

#include
#include
int main(){ char str[100005],s[100005],T=1; scanf("%s",str); int L=strlen(str); if (L%2==1) { printf("No\n"); return 0; } s[1]=str[0]; for (int i=1;i
0) { T--; continue; } else { T++; s[T]=str[i]; } } if (T==0) printf("Yes\n"); else printf("No\n"); return 0; }
View Code
E. Read Time
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mad scientist Mike does not use slow hard disks. His modification of a hard drive has not one, but n different heads that can read data in parallel.

When viewed from the side, Mike's hard drive is an endless array of tracks. The tracks of the array are numbered from left to right with integers, starting with 1. In the initial state the i-th reading head is above the track number hi. For each of the reading heads, the hard drive's firmware can move the head exactly one track to the right or to the left, or leave it on the current track. During the operation each head's movement does not affect the movement of the other heads: the heads can change their relative order; there can be multiple reading heads above any of the tracks. A track is considered read if at least one head has visited this track. In particular, all of the tracks numbered h1, h2, ..., hn have been read at the beginning of the operation.

 

Mike needs to read the data on m distinct tracks with numbers p1, p2, ..., pm. Determine the minimum time the hard drive firmware needs to move the heads and read all the given tracks. Note that an arbitrary number of other tracks can also be read.

Input

The first line of the input contains two space-separated integers n, m (1 ≤ n, m ≤ 105) — the number of disk heads and the number of tracks to read, accordingly. The second line contains n distinct integers hi in ascending order (1 ≤ hi ≤ 1010, hi < hi + 1) — the initial positions of the heads. The third line contains m distinct integers pi in ascending order (1 ≤ pi ≤ 1010, pi < pi + 1) - the numbers of tracks to read.

Please, do not use the %lld specifier to read or write 64-bit integers in С++. It is recommended to use the cin, cout streams or the %I64d specifier.

Output

Print a single number — the minimum time required, in seconds, to read all the needed tracks.

Sample test(s)
Input
3 4
2 5 6
1 3 6 8
Output
2
Input
3 3
1 2 3
1 2 3
Output
0
Input
1 2
165
142 200
Output
81
Note

The first test coincides with the figure. In this case the given tracks can be read in 2 seconds in the following way:

  1. during the first second move the 1-st head to the left and let it stay there;
  2. move the second head to the left twice;
  3. move the third head to the right twice (note that the 6-th track has already been read at the beginning).

One cannot read the tracks in 1 second as the 3-rd head is at distance 2 from the 8-th track.

题意:有n个磁头,m个位置需要访问.磁头一秒钟可以移动一格,求将m个格子全部访问所需要的最短时间.

思路: 二分答案,对每一种尝试用贪心法判定.假设当前的中间值为T,对于每一个磁头,他可以向左访问一些后折向右,也可以向右访问一些后折向左.

#include
#define i64 __int64int N,M;__int64 H[100005],R[100005];i64 abs(i64 x){ if (x<0) return -1*x; else return x;}i64 max(i64 x,i64 y){ return x>y ? x:y;}bool judge(i64 T){ int cur=1; i64 final; for (int i=1;i<=N;i++) { if (abs(H[i]-R[cur])>T) continue; if (R[cur]==H[i]) cur++; if (R[cur]
M);}int main(){ freopen("input.txt","r",stdin); while (scanf("%d%d",&N,&M)!=EOF) { int i; for ( i=1;i<=N;i++) scanf("%I64d",&H[i]); for ( i=1;i<=M;i++) scanf("%I64d",&R[i]); i64 l=-1,r=abs(H[1]-R[1])*2+abs(H[1]-R[M]),mid; while (l+1
>1; if (judge(mid)) r=mid; else l=mid; } printf("%I64d\n",r); } return 0;}
View Code

 

转载于:https://www.cnblogs.com/dramstadt/p/3322438.html

你可能感兴趣的文章